----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:25:07 08/28/2009 
-- Design Name: 
-- Module Name:    RxD - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;



entity RxD is
	Port ( 	CLK : in std_logic;   
				RxD : in std_logic;   
				schalter: out std_logic;
				byteData : out std_logic_vector(7 downto 0)
			);
end RxD;

architecture Behavioral of RxD is
	signal RxD_del: std_logic_vector(1 downto 0);
	signal a,b,c: std_logic;
	signal State: integer range 0 to 9:=0;
	signal busy: std_logic;
	signal Q: std_logic_vector(7 downto 0);
	

begin

	process(CLK)
		variable ClkDiv: std_logic_vector(3 downto 0);
		
	begin
      if CLK'event and CLK='1' then
			RxD_del<=RxD_del(0) & RxD; 
		if RxD_del="10" and busy='0' then 
	      ClkDiv:=x"0";
	      busy<='1';
	   elsif busy='1' then
	      ClkDiv:=ClkDiv+'1';
	   end if;

		
	   if ClkDiv=x"4" and busy='1' then
	      State<=State+1;
	      case State is
			
				 when 0=>
				schalter<='0';
					a<=RxD;          
				 when 1 to 8 =>  		
					Q<= RxD & Q(7 downto 1);
				 when 9 =>       		
					b<=RxD; 
					
				 when others =>  		
					c <= RxD;
			      State<=0;
				   busy<='0';
					byteData<=Q;
					schalter<='1';
						
	      end case;
	   end if;
      end if;
    end process;

end Behavioral;

