----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:07:37 08/28/2009 
-- Design Name: 
-- Module Name:    main - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------




library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity test8 is
    Port ( 	CLK : in std_logic;
				sio_RxD : in std_logic;	
				sio_TxD : out std_logic;
				S1_TxD : out STD_LOGIC;
				S2_TxD : out STD_LOGIC;
				S3_TxD : out STD_LOGIC;
				swt: in std_logic_vector(7 downto 0);
				led : out std_logic_vector(7 downto 0);
				btn : in std_logic_vector(3 downto 0));
end test8;

architecture Behavioral of test8 is
	signal Baude_CLK: std_logic;		 
	signal RxD_del: std_logic_vector(1 downto 0);
	signal RxD_out: std_logic;
	signal State: integer range 0 to 9:=0; 
	signal state_check: integer range 0 to 2:=0;
	signal Q: std_logic_vector(7 downto 0); 
	signal busy: std_logic; 
	signal a,b,c: std_logic;
	signal test,qq_check,Q_check, swt_in: std_logic_vector(7 downto 0);
	signal qq: std_logic_vector(7 downto 0):="00000000";
	signal btn_in: std_logic_vector(4 downto 0);
	signal schalter_check,schalter_txd:std_logic:='0';
	signal Cnt : integer;
	Signal luck,ss,loschen: std_logic:='0';
	signal Ram_rest_memory : std_logic_vector(7 downto 0):="00000000";
	signal a_zaehler_schalter: std_logic_vector(7 downto 0):="00000000";
	signal checksum_wert:std_logic_vector(7 downto 0):="00000000";
	signal data_fertig:std_logic:='0';
	signal TxD_01,TxD_02,TxD_03 : std_logic; 
	SIGNAL Txd_Done_1,LTxd_Done_1,Txd_Done_2,LTxd_Done_2,Txd_Done_3,LTxd_Done_3,rxddd1,rxddd2,rxddd3: std_logic; 
	signal q_out_1,q_out_2,q_out_3:std_logic_vector(7 DOWNTO 0):="00000000";

	component RxD is
		Port ( 	CLK : in std_logic;  
					RxD : in std_logic; 
					schalter: out std_logic;
					byteData : out std_logic_vector(7 downto 0)
				); 
	end component;
	
	component TxD_1 is
		Port ( 	CLK : in std_logic;   
					TxD : out std_logic;   
					swt_in: in std_logic_vector(7 downto 0)

				); 
	end Component;

	
	component Ram is
 
	PORT (
			Clk : IN std_logic;
			txd_data_1:out std_logic_vector(7 DOWNTO 0);
			txd_data_2:out std_logic_vector(7 DOWNTO 0);
			txd_data_3:out std_logic_vector(7 DOWNTO 0);
			btn : in std_logic_vector(3 downto 0);
			swt:  in std_logic_vector(7 downto 0);
			txd_done1:in std_logic;
			txd_done2:in std_logic;
			txd_done3:in std_logic;
			checksum_wert:OUT std_logic_vector(7 DOWNTO 0);
			Datain : IN std_logic_vector(7 DOWNTO 0);
			Read_Row_address : IN std_logic_vector(3 DOWNTO 0);
			Read_word_address : IN std_logic_vector(3 DOWNTO 0);
			ram_loschen: in std_logic;
			rest:out std_logic_vector(7 downto 0);
			a_zaehler:IN std_logic_vector(7 DOWNTO 0);
			data_fertig_schalter:in std_logic;
			Dataout : OUT std_logic_vector(7 DOWNTO 0)

			);
	end component;

	component senden1 is
	port( takt: in std_logic;
			zahl_rein_1: in std_logic_vector(7 downto 0);
			rxdd: out std_logic;
			senden_schalter: out std_logic
	);
	end component;

	component senden2 is
	port( takt: in std_logic;
			zahl_rein_2: in std_logic_vector(7 downto 0);
			rxdd: out std_logic;
			senden_schalter: out std_logic
	);
	end component;

	component senden3 is
	port( takt: in std_logic;
			zahl_rein_3: in std_logic_vector(7 downto 0);
			rxdd: out std_logic;
			senden_schalter: out std_logic
	);
	end component;

		
	
	
begin

	
	inst_Schreiben: RxD port map
		(CLK => Baude_CLK,
		 RxD => sio_RxD,
		 schalter => schalter_check,
		 byteData => Q_check);
		 
	inst_senden1: senden1 port map
		(  takt=>clk,
			zahl_rein_1=>q_out_1,
			senden_schalter=>txd_done_1,
			rxdd=>rxddd1
		);
		 
	inst_senden2: senden2 port map
		(  takt=>clk,
			zahl_rein_2=>q_out_2,
			senden_schalter=>txd_done_2,
			rxdd=>rxddd2
		);
		
	inst_senden3: senden3 port map
		(  takt=>clk,
			zahl_rein_3=>q_out_3,
			senden_schalter=>txd_done_3,
			rxdd=>rxddd3
		);
	
	Inst_Ram: Ram port map (
	 Clk=> Clk,
	 btn=> btn,
	 swt=>swt,
	 txd_done1=>txd_done_1,
	 txd_done2=>txd_done_2,
	 txd_done3=>txd_done_3,
	 Datain=>qq_check,   
	 a_zaehler=>a_zaehler_schalter,
	 Read_Row_address=> SWT(7 downto 4), 
	 Read_word_address=> SWT(3 downto 0), 
	 rest=>Ram_rest_memory,
	 ram_loschen=>loschen,
	 checksum_wert=>checksum_wert,
	 data_fertig_schalter=>data_fertig,
	 txd_data_1=>q_out_1,
	 txd_data_2=>q_out_2,
	 txd_data_3=>q_out_3,
	 dataout=>led 
	 );
	 
	 inst_Lesen: TxD_1 port map
		(CLK => CLK,
	    TxD => sio_TxD,
		 swt_in => qq
		);	




	
	
	
process(CLK)
variable ClkVT: integer range 0 to 80:=0;
begin
	 
      if CLK'event and CLK='1' then
        if ClkVT=80 then
			  ClkVT:=0;
			  Baude_CLK<=not Baude_CLK;
		  else
			  ClkVT:=ClkVT+1;
		  end if;
      end if;
		
	end process;
	



process(Clk)
variable platz:integer;	
begin
	if Clk'event and Clk='1'  then
		
	if schalter_check='1' then
		if 	luck='0' then
				luck<='1';

			case state_check is
				when 0 =>
					if Q_check = 239 then --EF
						loschen<='1';
						qq<=conv_std_logic_vector(241,8);--F1

						state_check<=state_check+1;	
					else
						qq<=conv_std_logic_vector(240,8);--F0
						loschen<='1';
						state_check<=0;

					end if;
					
				when 1 =>
						loschen<='0';
						platz:=conv_integer(Q_check);
						if conv_integer(Ram_rest_memory) > Platz then
							qq<=conv_std_logic_vector(242,8); --F2
							state_check<=state_check+1;
						else 
							qq<=conv_std_logic_vector(243,8); --F3
							state_check<=0;
						end if;		


				when 2 =>
					if Q_check=221 then	--DD
						qq<=conv_std_logic_vector(204,8); --CC
						state_check<=0;
						a_zaehler_schalter<="00000000";
						data_fertig<='1';
					else
						qq_check<=Q_check;
						a_zaehler_schalter<=a_zaehler_schalter+1;
						qq<=checksum_wert;-- F4 oder F5
					end if;
						
				when others =>
					state_check<=0;
			end case;

		end if;
		else
		luck<='0';
		end if;
end if;
end process;


S1_TxD<=not(rxddd1);
S2_TxD<=not(rxddd2);
S3_TxD<=not(rxddd3);

	
end Behavioral;

